// $Id: nasdsim_component_link.C,v 1.2 2000/04/17 00:05:07 ozaki Exp $

#include "nasdsim_component_link.h"

component_link::component_link (sim_component_id_t pId, sim_bandwidth_t linkBw,
				sim_len_t hdrSz)
{
  parentId = pId;
  linkBandwidth = linkBw;
  linkHdrSize = hdrSz;
  nextRequestBeginTime = 0;
}

component_link::~component_link()
{
}

void 
component_link::queue_request (sim_len_t size, 
			       simtime_t currentTime, 
			       simtime_t &completionTime)
{
  if (currentTime > nextRequestBeginTime) nextRequestBeginTime = currentTime;
  
  completionTime = nextRequestBeginTime + 0 + (size / linkBandwidth);
  
  nextRequestBeginTime = completionTime;
}
