// $Id: nasdsim_component_link.h,v 1.2 2000/04/17 00:05:07 ozaki Exp $

#if !defined (NASDSIM_COMPONENT_LINK_H)
#define NASDSIM_COMPONENT_LINK_H

#include "nasdsim_types.h"

class component_link {
 
 private:
  sim_bandwidth_t linkBandwidth;       // bandwidth of link in bytes / sec
  sim_len_t linkHdrSize;               // size of header
  simtime_t nextRequestBeginTime;      // time next pending request can begin in sec
  sim_component_id_t parentId;         // id of entity this link is associated with
  
 public:
  
  sim_len_t getLinkHdrSize (void) const {return linkHdrSize; }
  component_link (sim_component_id_t, sim_bandwidth_t, sim_len_t);
  ~component_link ();
  void queue_request (sim_len_t, simtime_t, simtime_t &);
};

#endif // !defined(NASDSIM_COMPONENT_LINK_H)
