// $Id: nasdsim_event_N2N.C,v 1.2 2000/04/30 03:43:03 bforney Exp $

#include "nasdsim_event_N2N.h"
#include "nasdsim_event_nasd.h"

//-------------------------------------------------------------------------------------
// event_N2N_nasd_send_to_switch
//-------------------------------------------------------------------------------------
events_t *
event_N2N_nasd_send_to_switch::simulate (components &comp)
{
    event_N2N_switch_recv_from_nasd *newEvent;
    component_link *nasdLink;
    simtime_t completionTime;
    sim_len_t requestSize;
      events_t *events;
    nasdLink = (comp.get_component_nasd (parameter->get_source_nasd ()))->getLink ();
    
    requestSize = nasdLink->getLinkHdrSize () + parameter->get_length ();
    
    nasdLink->queue_request (requestSize, start_time_, completionTime);
    
    newEvent = new event_N2N_switch_recv_from_nasd (completionTime, 
						    injection_time_,
						    parameter);
    events = new events_t;
    events->push(newEvent);
    
    return events;
}

#if defined(DEBUG)
void
event_N2N_nasd_send_to_switch::print(
				     ostream &output
				     ) const
{
    output << "event_N2N_nasd_send_to_switch: { start = " << start_time_;
    parameter->print (output);
    output << " }" << endl;
}
#endif // defined(DEBUG)
		
//-------------------------------------------------------------------------------------
// event_N2N_switch_recv_from_nasd
//-------------------------------------------------------------------------------------

events_t *
event_N2N_switch_recv_from_nasd::simulate (components &comp)
{
  event_N2N_switch_send_to_nasd *newEvent;
  simtime_t completionTime;
    events_t *events;
  // xxx assuming that it takes constant time inside a switch
  completionTime = start_time_ + NASDSIM_SWITCH_TIME;
  
  newEvent = new event_N2N_switch_send_to_nasd (completionTime, 
						injection_time_,
						parameter);
  events = new events_t;
  events->push(newEvent);
  
  return events;
}

#if defined(DEBUG)
void
event_N2N_switch_recv_from_nasd::print(
				       ostream &output
				       ) const
{
  output << "event_N2N_switch_recv_from_nasd: { start = " << start_time_;
  parameter->print (output);
  output << " }" << endl;
}
#endif // defined(DEBUG)

//-------------------------------------------------------------------------------------
// event_N2N_switch_send_to_nasd
//-------------------------------------------------------------------------------------

events_t *
event_N2N_switch_send_to_nasd::simulate (components &comp)
{
  event_N2N_nasd_recv_from_switch *newEvent;
  component_link *nasdLink;
  simtime_t completionTime;
  sim_len_t requestSize;
    events_t *events;
  nasdLink = 
      (comp.get_component_nasd (parameter->get_destination_nasd ()))->getLink ();
  
  requestSize = nasdLink->getLinkHdrSize () + parameter->get_length ();
  
  nasdLink->queue_request (requestSize, start_time_, completionTime);
  
  newEvent = new event_N2N_nasd_recv_from_switch (completionTime, 
						  injection_time_,
						  parameter);
 events = new events_t;
  events->push(newEvent);
  
  return events;
}

#if defined(DEBUG)
void
event_N2N_switch_send_to_nasd::print(
					ostream &output
					) const
{
  output << "event_N2N_switch_send_to_nasd: { start = " << start_time_;
  parameter->print (output);
  output << " }" << endl;
}
#endif // defined(DEBUG)
//-------------------------------------------------------------------------------------
// event_N2N_nasd_recv_from_switch
//-------------------------------------------------------------------------------------

events_t *
event_N2N_nasd_recv_from_switch::simulate (components &comp)
{
    event_nasd_N2N *newEvent;
    newEvent = new event_nasd_N2N(dynamic_cast<event *>(this),
				  start_time_, parameter);

    events_t *events;

    events = new events_t;
    events->push(newEvent);
    
    return events;
}

#if defined(DEBUG)
void
event_N2N_nasd_recv_from_switch::print(
				       ostream &output
				       ) const
{
    output << "event_N2N_nasd_recv_from_switch: { start = " << start_time_;
    parameter->print (output);
    output << " }" << endl;
}
#endif // defined(DEBUG)
