// $Id: nasdsim_event_READ.h,v 1.8 2000/05/09 01:57:06 ozaki Exp $

#if !defined(NASDSIM_EVENT_READ_H)
#define NASDSIM_EVENT_READ_H

#include "nasdsim_event.h"
#include "nasdsim_types.h"
#include "nasdsim_components.h"
#include "nasdsim_param.h"

class event_READ_client_read : public event
{
 private:
    
    param_read *parameter;
    
 public:
    
    event_READ_client_read (simtime_t stT, simtime_t inT, param_read *p)
	: event (stT, inT), parameter (p) {};
    ~event_READ_client_read() {};
    
    events_t *simulate(components &comp);
    
    // accessors
    sim_component_id_t get_nasd_id (void) { return parameter->get_nasd_id (); }
    sim_stream_id_t get_stream_id (void) { return parameter->get_stream_id (); }
    sim_component_id_t get_client_id (void) { return parameter->get_client_id (); }
    sim_len_t get_total_length (void) { return parameter->get_total_length (); }
    
#if defined (DEBUG)
    void print(ostream &o) const;
#endif
};

class event_READ_switch_recv_from_client : public event 
{
 private:
  
    param_read *parameter;

 public:
  
    event_READ_switch_recv_from_client (simtime_t stT, simtime_t inT, param_read *p) 
	: event (stT, inT), parameter (p) {};
    ~event_READ_switch_recv_from_client () {};
    
    events_t *simulate (components &comp);
  
#if defined (DEBUG)
  void print(ostream &o)const;
#endif
};

class event_READ_switch_send_to_nasd : public event 
{
 private:
  
    param_read *parameter;
    
 public:
  
  event_READ_switch_send_to_nasd (simtime_t stT, simtime_t inT, param_read *p)
      : event (stT, inT), parameter (p) {};
  ~event_READ_switch_send_to_nasd () {};
  
  events_t *simulate(components &comp);
  
#if defined (DEBUG)
  void print(ostream &o)const;
#endif
};

class event_READ_nasd_recv_from_switch : public event 
{
 private:
    
    param_read *parameter;
    
 public:
    
    event_READ_nasd_recv_from_switch (simtime_t stT, simtime_t inT, param_read *p)
	: event (stT, inT), parameter (p) {};
    ~event_READ_nasd_recv_from_switch () {};
    
    events_t *simulate(components &comp);
    
#if defined (DEBUG)
  void print(ostream &o)const;
#endif
};

/******************************
 *                            *
 * Brian's code comes in here **********************************************************
 *                            *
 ******************************/

class event_READ_nasd_send_to_switch : public event
{
 private:
  
    param_read *parameter;
  
 public:
  
    event_READ_nasd_send_to_switch (event *evt, simtime_t stT, param_read *p)
	: event (evt, stT), parameter (p) {};
    ~event_READ_nasd_send_to_switch () {};
    events_t *simulate(components &comp);
    
#if defined (DEBUG)
    void print(ostream &o)const;
#endif
};

class event_READ_switch_recv_from_nasd : public event
{
 private:
  
    param_read *parameter;

 public:
  
  event_READ_switch_recv_from_nasd (simtime_t stT, simtime_t inT, param_read *p)
      : event (stT, inT), parameter (p) {};
  ~event_READ_switch_recv_from_nasd () {};
  events_t *simulate(components &comp);

#if defined (DEBUG)
  void print(ostream &o)const;
#endif
};

class event_READ_switch_send_to_client : public event
{
 private:
  
    param_read *parameter;
  
 public:
  
  event_READ_switch_send_to_client (simtime_t stT, simtime_t inT, param_read *p)
      : event (stT, inT), parameter (p) {};
  ~event_READ_switch_send_to_client () {};
  events_t *simulate(components &comp);

#if defined (DEBUG)
  void print(ostream &o)const;
#endif
};

class event_READ_client_recv_from_switch : public event
{
 private:
  
    param_read *parameter;
  
 public:
  
  event_READ_client_recv_from_switch (simtime_t stT, simtime_t inT, param_read *p)
: event (stT, inT), parameter (p) {};
  ~event_READ_client_recv_from_switch () {};
  events_t *simulate(components &comp);
  
#if defined (DEBUG)
  void print(ostream &o)const;
#endif

};

#endif // #define NASDSIM_EVENT_READ_H





